data:extend({
  {
    type = "technology",
    name='green-beacon',
    prerequisites = {'clean-power-MK3', 'steel-processing',},
    icon = "__replicators__/graphics/icons/green-beacon.png",
    effects = {
      {type = 'unlock-recipe', recipe = 'green-beacon'},
      {type = 'unlock-recipe', recipe = 'carbon-entangler'}
    },
    unit = research(100, 2, 2, 0, 0, 15)
  },
  {
    type = "item",
    name = "green-beacon",
    icon = "__replicators__/graphics/icons/green-beacon.png",
    flags = {"goes-to-quickbar"},
    subgroup = "module",
    order = "a[green-beacon]",
    place_result = "green-beacon",
    stack_size = 10
  },
  {
    type = "recipe",
    name = "green-beacon",
    enabled = "false",
    energy_required = 15,
    ingredients =
    {
      {"electronic-circuit", 10},
      {"steel-plate", 10},
      {"copper-cable", 10},
      {"ion-conduit", 1}
    },
    result = "green-beacon"
  },

  {
    type = "beacon",
    name = "green-beacon",
    icon = "__replicators__/graphics/icons/green-beacon.png",
    flags = {"placeable-player", "player-creation"},
    minable = {mining_time = 1, result = "green-beacon"},
    max_health = 200,
    corpse = "big-remnants",
    dying_explosion = "huge-explosion",
    collision_box = {{-1.2, -1.2}, {1.2, 1.2}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    allowed_effects = {"pollution"},
    base_picture =
    {
      filename = "__replicators__/graphics/entity/green-beacon/green-beacon-base.png",
      width = 116,
      height = 93,
      shift = { 0.34, 0.06}
    },
    animation =
    {
      filename = "__base__/graphics/entity/basic-beacon/basic-beacon-antenna.png",
      width = 54,
      height = 50,
      line_length = 8,
      frame_count = 32,
      shift = { -0.03, -1.72},
      animation_speed = 0.5
    },
    animation_shadow =
    {
      filename = "__base__/graphics/entity/basic-beacon/basic-beacon-antenna-shadow.png",
      width = 63,
      height = 49,
      line_length = 8,
      frame_count = 32,
      shift = { 3.12, 0.5},
      animation_speed = 0.5
    },
    radius_visualisation_picture =
    {
      filename = "__base__/graphics/entity/basic-beacon/beacon-radius-visualization.png",
      width = 12,
      height = 12
    },
    supply_area_distance = 24,
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input"
    },
    energy_usage = "480kW",
    distribution_effectivity = 0.15,
    num_module_slots = 8
  },
{
      type = "recipe",
      name = "carbon-entangler",
      enabled = "false",
      ingredients = {
        {'ion-conduit', 1},
        {'electronic-circuit', 5},
        {'steel-plate', 5}
      },
      result = "carbon-entangler"
  },

  {
    type = "module",
    name = "carbon-entangler",
    icon = "__replicators__/graphics/icons/carbon-entangler.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "replication-resources",
    order = "a[ion-conduit]-c",
    stack_size = 50,
    effect = {pollution = {bonus = -0.05}}
  },


})