require "util"

ion_turret_extension =
{
  filename = "__replicators__/graphics/entity/ion-turret/ion-turret-extension.png",
  priority = "medium",
  width = 131,
  height = 74,
  direction_count = 4,
  frame_count = 5,
  axially_symmetrical = false,
  shift = {1.171875, -0.34375}
}

data:extend({

  {
    type = "item",
    name = "ion-turret",
    icon = "__replicators__/graphics/icons/ion-turret.png",
    flags = {"goes-to-quickbar"},
    subgroup = "defensive-structure",
    order = "b[turret]-c[ion-turret]",
    place_result = "ion-turret",
    stack_size = 50
  },
  {
    type = "recipe",
    name = "ion-turret",
    enabled = "false",
    ingredients =
    {
      {"ion-conduit", 2},
      {"advanced-circuit", 20},
      {"laser-turret", 2}
    },
    result = "ion-turret"
  },

  {
    type = "electric-turret",
    name = "ion-turret",
    icon = "__replicators__/graphics/icons/ion-turret.png",
    flags = { "placeable-player", "placeable-enemy", "player-creation"},
    minable = { mining_time = 0.5, result = "ion-turret" },
    max_health = 400,
    corpse = "small-remnants",
    collision_box = {{ -0.4, -0.4}, {0.4, 0.4}},
    selection_box = {{ -0.4, -0.4}, {0.4, 0.4}},
    rotation_speed = 0.01,
    preparing_speed = 0.05,
    dying_explosion = "huge-explosion",
    folding_speed = 0.05,
    energy_source =
    {
      type = "electric",
      buffer_capacity = "500kJ",
      input_flow_limit = "1920kW",
      drain = "18kW",
      usage_priority = "primary-input"
    },
    folded_animation = (function()
                          local res = util.table.deepcopy(ion_turret_extension)
                          res.frame_count = 1
                          res.line_length = 1
                          return res
                       end)(),
    preparing_animation = ion_turret_extension,
    prepared_animation =
    {
      filename = "__replicators__/graphics/entity/ion-turret/ion-turret.png",
      priority = "medium",
      width = 131,
      height = 72,
      direction_count = 64,
      frame_count = 1,
      line_length = 8,
      axially_symmetrical = false,
      shift = {1.328125, -0.375}
    },
    folding_animation = (function()
                          local res = util.table.deepcopy(ion_turret_extension)
                          res.run_mode = "backward"
                          return res
                       end)(),
    base_picture =
    {
      filename = "__replicators__/graphics/entity/ion-turret/ion-turret-base.png",
      priority = "high",
      width = 43,
      height = 28,
      shift = { 0.109375, 0.03125 }
    },
    attack_parameters =
    {
      ammo_category = "electric",
      cooldown = 40,
      projectile_center = {0, 0},
      projectile_creation_distance = 0.6,
      range = 30,
      ammo_type =
      {
        type = "projectile",
        category = "laser-turret",
        energy_consumption = "600kJ",
        action =
        {
          {
            type = "direct",
            action_delivery =
            {
              {
                type = "projectile",
                projectile = "blue-laser",
                -- starting_speed = 0.28
                starting_speed = 1.5
              }
            }
          }
        }
      },
      sound =
      {
        {
          filename = "__base__/sound/laser.ogg",
          volume = 0.4
        }
      }
    }
  },

})