repl_data = {}

local water_speed = 0.1
local ore_speed = 3.5
local stone_speed = 2.75
local smelt_speed = 3.5
local oil_speed = 3
local ion_speed = 60
local petrol_speed = 7/3 + 4/3 * oil_speed + water_speed --calculed on cracking heavy and light oil to petrol based on nomal oil processing -- ~6,5
--local petrol_speed = 5/3 + (10 * oil_speed + 11 * water_speed) / 9 --calculed on cracking heavy and light oil to petrol based on advanced oil processing -- ~5,244
local heavy_oil_speed = 10/3 * oil_speed + 5/3 -- ~11.666  based on nomal oil processing
--local heavy_oil_speed = 10 * oil_speed + 5 + 5 * water_speed -- ~36  based on advanced oil processing
local plate_speed = ore_speed + smelt_speed 
local gear_speed = plate_speed * 2 + 0.5 
local chem_speed = ore_speed + 3 * petrol_speed + 1 
local sulfur_speed = (3 * petrol_speed + 3 * water_speed + 1) / 2 
local acid_speed = (plate_speed + 5 * sulfur_speed + 10 * water_speed + 1) / 5 
local battery_speed = 2 * plate_speed + 2 * acid_speed + 5 
local wire_speed = plate_speed / 2 + 0.25 
local circuit_speed = plate_speed + 3 * wire_speed + 0.5 
local adv_circ_speed = 2 * chem_speed + 2 * circuit_speed + 4 * wire_speed + 8 
local steel_speed = plate_speed * 5 + smelt_speed * 5 

--function which represents a "penalty" because you dont need the infrastructure of a vanilla factory. The more "advanced" the higher the penalty
function repl_penalty(time)
  if time < 10 then return time
  else return math.ceil(time * (1 + 0.0001 * time) + 0.5)
  end
end

data:extend({
  {
    type = "item-group",
    name = "replication",
    icon = "__base__/graphics/technology/research-effectivity.png",
    inventory_order = "g",
    order = "e"
  },
  {
    type = "item-subgroup",
    name = "replication-recipes",
    group = 'replication',
    order = 'ea',
  },
  {
    type = 'item-subgroup',
    name = 'replicators',
    group = 'replication',
    order = 'eb'
  },
  {
    type = 'item-subgroup',
    name = 'clean-power',
    group = 'replication',
    order = 'ec',
  },
  {
    type = 'item-subgroup',
    name = 'replication-research',
    group = 'replication',
    order = 'ed',
  },
  {
    type = 'item-subgroup',
    name = 'replication-resources',
    group = 'replication',
    order = 'ef',
  }
})


function repl_recipe(opts)
  local item = opts['item']
  local reps = opts['reps']
  local tier = opts['tier']
  local prerequisites = opts['prerequisites']
  local quantity = opts['quantity'] or 1
  local time = opts['time'] or 0.5
  local unit = opts['unit']


  -- Require the previous tier
  prerequisites[#prerequisites + 1] = 'repltech-replication-' .. tier

  -- Default reps
  if reps == nil then
    reps = 100
    --reps = 50 * 2 ^ (tier - 1)
    --[[if tier == 1 then
      reps = 10
    else
      reps = 50 * 2 ^(tier - 2)
    end
    --]]
  end
  -- 600
  -- 1200
  -- 6k
  -- 30k
  -- 125k
  -- default unit
  if unit == nil then
    if tier == 1 then
      unit = repl_research(reps, 1, 1, 0, 0, 5)
    elseif tier == 2 then
      unit = repl_research(reps, 2, 2, 0, 0, 5)
    elseif tier == 3 then
      unit = repl_research(reps, 0, 2, 2, 0, 5)
    elseif tier == 4 then
      unit = repl_research(reps, 0, 0, 2, 2, 5)
    elseif tier == 5 then
      unit = repl_research(reps, 0, 0, 0, 10, 5)
    end
  end

  repl_data[#repl_data + 1] = {
    name = "repltech-"..item,  type = "technology", order = "c-a-".. tier,
    prerequisites = prerequisites,
    icon = "__replicators__/graphics/icons/repl-" .. item .. ".png",
    effects = {
      { type = "unlock-recipe", recipe = "repl-" .. item},
    },
    unit = unit,
  }
  repl_data[#repl_data + 1] = {
    type = "recipe",
    category = "replication-"..tier,
    name = "repl-" .. item,
    enabled = "false",
    energy_required = repl_penalty(time),
    icon = "__replicators__/graphics/icons/repl-" .. item .. ".png",

    ingredients = {},
    result = item,
    result_count = quantity,
    subgroup='replication-recipes',
    order = 'r-' .. tier .. '[' .. item .. ']',
  }

end


function repl_tier(tier, unit)
  local preq = {}
  if tier > 1 then
    preq[#preq+1] = 'repltech-replication-'..(tier-1)
  end
  if tier == 2 then
    preq[#preq + 1] = 'superconductor'
  end
  if tier == 4 then
    preq[#preq + 1] = 'ion-conduit'
  end
  effects = {
      {
        type = "unlock-recipe",
        recipe = "replicator-"..tier
      },
  }
  if tier == 1 then
    effects[#effects + 1] = {
      type = 'unlock-recipe',
      recipe = 'replication-lab'
    }
  end
  repl_data[#repl_data + 1] = {
    type = "technology",
    name = "repltech-replication-" .. tier,
    icon = "__replicators__/graphics/icons/replicator-"..tier..".png",
    effects = effects,

    prerequisites = preq,
    unit = unit,
    order = "c-a",
  }
  repl_data[#repl_data + 1] = {
    type = "recipe-category",
    name = "replication-"..tier
  }

end

repl_tier(1, repl_research(100, 1, 1, 0, 0, 5))
repl_tier(2, repl_research(100, 2, 2, 0, 0, 5))
repl_tier(3, repl_research(100, 0, 2, 2, 0, 5))
repl_tier(4, repl_research(100, 0, 0, 2, 2, 5))
repl_tier(5, repl_research(100, 0, 0, 0, 10, 5))


--[[repl_recipe({
  tier=1,
  item='ion-conduit',
  time = ion_speed,
  prerequisites={}
})--]]
repl_recipe({
  tier = 1,
  item = 'coal',
  time = ore_speed,
  prerequisites = {}
})
repl_recipe({
  tier=1,
  item='stone',
  time = stone_speed,
  prerequisites={}
})
repl_recipe({
  tier=1,
  item='wood',
  time = ore_speed - 1,
  prerequisites={}
})
repl_recipe({
  tier=1,
  item='iron-ore',
  time = ore_speed,
  prerequisites={}
})
repl_recipe({
  tier=1,
  item='copper-ore',
  time = ore_speed,
  prerequisites={}
})
repl_recipe({
  tier=2,
  item='iron-plate',
  time = plate_speed,
  reps = 50,
  prerequisites={'repltech-iron-ore'}
})
repl_recipe({
  tier=2,
  item='copper-plate',
  time = plate_speed,
  reps = 50,
  prerequisites={'repltech-copper-ore'}
})
repl_recipe({
  tier=2,
  item='stone-brick',
  time = stone_speed * 2 + smelt_speed,
  prerequisites={'repltech-stone'}
})
repl_recipe({
  tier=2,
  item = 'pipe',
  time = plate_speed + 0.5,
  prerequisites={'repltech-iron-plate'}
})
repl_recipe({
  tier=2,
  item = 'copper-cable',
  time = wire_speed,
  prerequisites={'repltech-copper-plate'}
})
repl_recipe({
  tier=2,
  item='solar-panel-MK1',
  time = ion_speed + plate_speed * 5,
  --reps = 150,

  prerequisites={'clean-power-MK1', 'repltech-copper-plate'}
})
repl_recipe({
  tier=2,
  item='accumulator-MK1',
  time = ion_speed + plate_speed * 5,
  --reps = 150,
  prerequisites={'clean-power-MK1', 'repltech-copper-plate'}
})
repl_recipe({
  tier = 2,
  item = 'stone-wall',
  time = (stone_speed * 2 + smelt_speed) * 5 + 0.5,
  prerequisites={'repltech-stone-brick'}
})
repl_recipe({
  tier = 3,
  item='steel-plate',
  time = steel_speed,
  prerequisites={'repltech-iron-plate'}
})
repl_recipe({
  tier = 3,
  item='plastic-bar',
  time = chem_speed,
  prerequisites={}
})
repl_recipe({
  tier = 3,
  item = 'sulfur',
  time = sulfur_speed * 2, --speed is for one sulfur
  quantity = 2,
  prerequisites={'repltech-iron-plate'}
})
repl_recipe({
  tier = 3,
  item = 'iron-gear-wheel',
  time = gear_speed,
  prerequisites={'repltech-iron-plate'}
})
repl_recipe({
  tier = 3,
  item = 'electronic-circuit',
  time = circuit_speed,
  prerequisites={'repltech-copper-cable', 'repltech-iron-plate'}
})
repl_recipe({
  tier = 3,
  item = 'battery',
  time = battery_speed,
  --reps = 300,
  prerequisites={'repltech-sulfur', 'repltech-copper-plate'}
})
repl_recipe({
  tier = 4,
  item = 'basic-transport-belt',
  time = plate_speed + gear_speed + 0.5,
  prerequisites={'repltech-iron-gear-wheel'}
})
repl_recipe({
  tier = 4,
  item = 'basic-inserter',
  time = plate_speed + gear_speed + circuit_speed + 0.5,
  prerequisites={'repltech-electronic-circuit', 'repltech-iron-gear-wheel'}
})
repl_recipe({
  tier = 4,
  item = 'advanced-circuit',
  time = adv_circ_speed,
  prerequisites = {'advanced-electronics'}
})
repl_recipe({
  tier = 4,
  item = 'alien-artifact',
  time = 1708, -- time * (1 + 0.0001 * time);a=0.0001 b=1 , c=2000 -> time=(-b+(b^2+4*a*c)^0.5) / (2a); where c is the target time
  prerequisites={}
})
repl_recipe({
  tier = 5,
  item = 'processing-unit',
  time = 15 + 20 * circuit_speed + 5 * adv_circ_speed + 0.5 * acid_speed, -- ~ 1000
  prerequisites={'advanced-electronics'}
})
data:extend(repl_data)

data:extend({
  {
    type = "recipe",
    name = "repl-lubricant",
    category = "chemistry",
    enabled = "false",
    energy_required = 1 + 10 / 3 * oil_speed,
    ingredients =
    {
    },
    results=
    {
      {type="fluid", name="lubricant", amount=1}
    },
    icon='__replicators__/graphics/icons/repl-lubricant.png',
    subgroup='replication-recipes',
  },
  {
    name = "repltech-lubricant",  type = "technology", order = "c-a-3",
    prerequisites = {'repltech-replication-3'},
    icon = "__replicators__/graphics/icons/repl-lubricant.png",
    effects = {
      { type = "unlock-recipe", recipe = "repl-lubricant" }
    },
    unit = research(200, 2, 2, 0, 0, 5)
  },
  {
    type = "recipe",
    name = "repl-crude-oil",
    category = "chemistry",
    enabled = "false",
    energy_required = 5 * oil_speed,
    ingredients ={},
    results=
    {
      {type="fluid", name="crude-oil", amount=5}
    },
    icon='__replicators__/graphics/icons/repl-crude-oil.png',
    subgroup='replication-recipes',
  },
  {
    name = "repltech-crude-oil",  type = "technology", order = "c-a-2",
    prerequisites = {'repltech-replication-2'},
    icon = "__replicators__/graphics/icons/repl-crude-oil.png",
    effects = {
      { type = "unlock-recipe", recipe = "repl-crude-oil" }
    },
    unit = research(200, 1, 1, 0, 0, 5)
  }
})
