local base_power = 90
local factor = 2.5

data:extend(
{
  {
    type = "item",
    name = "solar-panel-MK1",
    icon = "__replicators__/graphics/icons/solar/solar-panel.png",
    flags = {"goes-to-quickbar"},
    subgroup = "clean-power",
    order = "d[solar-panel]-a[solar-panel]",
    place_result = "solar-panel-MK1",
    stack_size = 50,

  },{
    type = "item",
    name = "solar-panel-MK2",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK2.png",
    flags = {"goes-to-quickbar"},
    subgroup = "clean-power",
    order = "d[solar-panel]-a[solar-panel]",
    place_result = "solar-panel-MK2",
    stack_size = 50
  },
   {
    type = "item",
    name = "solar-panel-MK3",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK3.png",
    flags = {"goes-to-quickbar"},
    subgroup = "clean-power",
    order = "d[solar-panel]-a[solar-panel]",
    place_result = "solar-panel-MK3",
    stack_size = 50
  },
    {
    type = "item",
    name = "solar-panel-MK4",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK4.png",
    flags = {"goes-to-quickbar"},
    subgroup = "clean-power",
    order = "d[solar-panel]-a[solar-panel]",
    place_result = "solar-panel-MK4",
    stack_size = 50
  },
    {
    type = "item",
    name = "solar-panel-MK5",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK5.png",
    flags = {"goes-to-quickbar"},
    subgroup = "clean-power",
    order = "d[solar-panel]-a[solar-panel]",
    place_result = "solar-panel-MK5",
    stack_size = 50
  },
}
)

data:extend(
{
  {
    type = "recipe",
    name = "solar-panel-MK1",
  category = "crafting",
    enabled = "false",
  energy_required = 0.5,
    ingredients =
    {
      {"electronic-circuit", 2},
      {"rare-earth-magnet", 1},
      {"copper-plate", 5},
    },
    result = "solar-panel-MK1"
  },
  {
    type = "recipe",
    name = "solar-panel-MK2",
  category = "crafting",
    enabled = "false",
  energy_required = 0.5,
    ingredients =
    {
      {"solar-panel-MK1", 1},
      {"electronic-circuit", 8},
      {"superconductor", 1},
    },
    result = "solar-panel-MK2"
  },
  {
    type = "recipe",
    name = "solar-panel-MK3",
    category = "crafting",
    enabled = "false",
    energy_required = 0.5,
    ingredients =
    {
      {"superconductor", 2},
      {"advanced-circuit", 2},
      {"solar-panel-MK2", 1},
    },
    result = "solar-panel-MK3"
  },
   {
    type = "recipe",
    name = "solar-panel-MK4",
  category = "crafting",
    enabled = "false",
  energy_required = 0.5,
    ingredients =
    {
      {"ion-conduit", 1},
      {"advanced-circuit", 5},
      {"solar-panel-MK3", 1},
    },
    result = "solar-panel-MK4"
  },
   {
    type = "recipe",
    name = "solar-panel-MK5",
  category = "crafting",
    enabled = "false",
  energy_required = 0.5,
    ingredients =
    {
      {"ion-conduit", 2},
      {"processing-unit", 2},
      {"solar-panel-MK4", 1},
    },
    result = "solar-panel-MK5"
  },
  })

data:extend({
   {
    type = "solar-panel",
    name = "solar-panel-MK1",
    fast_replaceable_group = "solar-panel",
    icon = "__replicators__/graphics/icons/solar/solar-panel.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "solar-panel-MK1"},
    max_health = 200,
    corpse = "big-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1.0, -1.0}, {1.0, 1.0}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    picture =
    {
      filename = "__replicators__/graphics/entity/solar/solar-panel.png",
      priority = "high",
      width = 104,
      height = 96,
      scale= 0.67
    },
    production = base_power * factor^0 ..'kW'
  },
   {
    type = "solar-panel",
    name = "solar-panel-MK2",
    fast_replaceable_group = "solar-panel",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK2.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "solar-panel-MK2"},
    max_health = 200,
    corpse = "big-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1.0, -1.0}, {1.0, 1.0}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    picture =
    {
      filename = "__replicators__/graphics/entity/solar/solar-panel-MK2.png",
      priority = "high",
      width = 104,
      height = 96,
      scale= 0.67
    },
    production = base_power * factor^1 ..'kW'
  },
   {
    type = "solar-panel",
    name = "solar-panel-MK3",
    fast_replaceable_group = "solar-panel",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK3.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "solar-panel-MK3"},
    max_health = 300,
    corpse = "big-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1.0, -1.0}, {1.0, 1.0}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    picture =
    {
      filename = "__replicators__/graphics/entity/solar/solar-panel-MK3.png",
      priority = "high",
      width = 104,
      height = 96,
      scale= 0.67
    },
    production = base_power * factor^2 ..'kW'
  },
     {
    type = "solar-panel",
    name = "solar-panel-MK4",
    fast_replaceable_group = "solar-panel",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK4.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "solar-panel-MK4"},
    max_health = 400,
    corpse = "big-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1.0, -1.0}, {1.0, 1.0}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    picture =
    {
      filename = "__replicators__/graphics/entity/solar/solar-panel-MK4.png",
      priority = "high",
      width = 104,
      height = 96,
      scale= 0.67
    },
    production = base_power * factor^3 ..'kW'
  },
     {
    type = "solar-panel",
    name = "solar-panel-MK5",
    fast_replaceable_group = "solar-panel",
    icon = "__replicators__/graphics/icons/solar/solar-panel-MK5.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "solar-panel-MK5"},
    max_health = 500,
    corpse = "big-remnants",
    collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-1.0, -1.0}, {1.0, 1.0}},
    energy_source =
    {
      type = "electric",
      usage_priority = "primary-output"
    },
    picture =
    {
      filename = "__replicators__/graphics/entity/solar/solar-panel-MK5.png",
      priority = "high",
      width = 104,
      height = 96,
      scale= 0.67
    },
    production = base_power * factor^4 ..'kW'
  },
})